﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SA0314DllTest
{
    public partial class Form1 : Form
    {
        ushort mNumPts = 16;

        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnHandleCreated(EventArgs e)
        {
            base.OnHandleCreated(e);
            this.SA0314.RegisterHandle(Handle);
        }

        protected override void WndProc(ref Message m)
        {
            this.SA0314.ParseMessages(ref m);
            base.WndProc(ref m);	// pass message on to base form
        }

        private void SA0314_OnDeviceReady(object sender, EventArgs e)
        {
            label1.Text = "Device Ready!";
            btnSingle.Enabled = true;
            btnStart.Enabled = true;
            SA0314.SetIfGain(4);
            cbLnaGain.SelectedIndex = 4;
            SA0314.SetBw(10);
            cbBw.SelectedIndex = 10;
        }

        private void SA0314_OnDeviceRemoved(object sender, EventArgs e)
        {
            label1.Text = "Device Removed!";
            btnSingle.Enabled = false;
            btnStart.Enabled = false;
        }

        private void SA0314_OnSweepComplete(object sender, EventArgs e)
        {
            if (InvokeRequired)
            {
                try
                {
                    Invoke(new EventHandler(SA0314_OnSweepComplete), new object[] { sender, e });
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
            else
            {
                listBox1.Items.Clear();
                for (int i = 0; i < SA0314.swpData.Count; i++)
                {
                    listBox1.Items.Add(i + ":\t" + SA0314.swpData[i].X.ToString("f3") + ",\t" + SA0314.swpData[i].Y.ToString("f2"));
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            SA0314.UnregisterHandle();
            SA0314.StopSweep();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            SA0314.StartSweep(2400, 0.325, mNumPts);    //Start Freq (MHz), Step Size (MHz), Number of points
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            SA0314.StopSweep();
        }

        private void btnSingle_Click(object sender, EventArgs e)
        {
            SA0314.SweepSingle(2400, 0.325, mNumPts);    //Start Freq (MHz), Step Size (MHz), Number of points
        }

        private void cbLnaGain_SelectedIndexChanged(object sender, EventArgs e)
        {
            SA0314.SetIfGain((byte)cbLnaGain.SelectedIndex);
        }

        private void cbBw_SelectedIndexChanged(object sender, EventArgs e)
        {
            SA0314.SetBw((byte)cbBw.SelectedIndex);
        }
    }
}
